$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: semaphore.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		セマフォ機能のテンプレートファイル
$

$
$  AID_SEMの処理
$
$num_asemid = 0$
$FOREACH i ASEM.ORDER_LIST$
$	// nosemが負の場合（E_PAR）
	$IF ASEM.NOSEM[i] < 0$
		$ERROR ASEM.TEXT_LINE[i]$E_PAR:$SPC$
			$FORMAT(_("illegal %1% `%2%\' in %3%"),
									"nosem", ASEM.NOSEM[i], "AID_SEM")$
		$END$
	$END$
	$num_asemid = num_asemid + ASEM.NOSEM[i]$
$END$
$num_semid = LENGTH(SEM.ID_LIST) + num_asemid$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_SEMID	$num_semid$$NL$
$FOREACH id SEM.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Semaphore Functions$NL$
$SPC$*/$NL$
$NL$

$
$  セマフォのID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id SEM.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$$NL$
$END$

$
$  静的に生成されたセマフォの数
$
#define TNUM_SSEMID	$LENGTH(SEM.ID_LIST)$$NL$
$NL$

$
$  セマフォID番号の最大値
$
const ID _kernel_tmax_semid = (TMIN_SEMID + TNUM_SEMID - 1);$NL$
const ID _kernel_tmax_ssemid = (TMIN_SEMID + TNUM_SSEMID - 1);$NL$
$NL$

$
$  セマフォ初期化ブロック
$
$IF LENGTH(SEM.ID_LIST)$
	$FOREACH semid SEM.ID_LIST$
$		// sematrが無効の場合（E_RSATR）［NGKI1456］
$		//（TA_TPRI以外のビットがセットされている場合）
		$IF (SEM.SEMATR[semid] & ~TA_TPRI) != 0$
			$ERROR SEM.TEXT_LINE[semid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"sematr", SEM.SEMATR[semid], semid, "CRE_SEM")$
			$END$
		$END$

$		// (1 <= maxsem && maxsem <= TMAX_MAXSEM)でない場合（E_PAR）［NGKI1468］
		$IF !(1 <= SEM.MAXSEM[semid] && SEM.MAXSEM[semid] <= TMAX_MAXSEM)$
			$ERROR SEM.TEXT_LINE[semid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"maxsem", SEM.MAXSEM[semid], semid, "CRE_SEM")$
			$END$
		$END$

$		// (0 <= isemcnt && isemcnt <= maxsem)でない場合（E_PAR）［NGKI1466］
		$IF !(0 <= SEM.ISEMCNT[semid]
								&& SEM.ISEMCNT[semid] <= SEM.MAXSEM[semid])$
			$ERROR SEM.TEXT_LINE[semid]$E_PAR:$SPC$
				$FORMAT(_("too large %1% `%2%\' of `%3%\' in %4%"),
							"isemcnt", SEM.ISEMCNT[semid], semid, "CRE_SEM")$
			$END$
		$END$
	$END$

$	// セマフォ初期化ブロック
	const SEMINIB _kernel_seminib_table[TNUM_SSEMID] = {$NL$
	$JOINEACH semid SEM.ID_LIST ",\n"$
		$TAB${$SPC$
			($SEM.SEMATR[semid]$),$SPC$
			($SEM.ISEMCNT[semid]$),$SPC$
			($SEM.MAXSEM[semid]$)$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const SEMINIB, _kernel_seminib_table);$NL$
$END$$NL$

$
$  動的生成セマフォ用のセマフォ初期化ブロック
$
$IF num_asemid > 0$
	SEMINIB _kernel_aseminib_table[$num_asemid$];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(SEMINIB, _kernel_aseminib_table);$NL$
$END$$NL$

$
$  セマフォ管理ブロックとセマフォ機能初期化関数
$
$IF num_semid > 0$
	SEMCB _kernel_semcb_table[TNUM_SEMID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_semaphore();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(SEMCB, _kernel_semcb_table);$NL$
$END$$NL$
