$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: messagebuf.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		メッセージバッファ機能のテンプレートファイル
$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_MBFID	$LENGTH(MBF.ID_LIST)$$NL$
$FOREACH id MBF.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Message Buffer Functions$NL$
$SPC$*/$NL$
$NL$

$
$  メッセージバッファのID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id MBF.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  メッセージバッファID番号の最大値
$
const ID _kernel_tmax_mbfid = (TMIN_MBFID + TNUM_MBFID - 1);$NL$
$NL$

$
$  メッセージバッファ初期化ブロック
$
$IF LENGTH(MBF.ID_LIST)$
	$FOREACH mbfid MBF.ID_LIST$
$		// mbfatrが無効の場合（E_RSATR）［NGKI3303］
$		//（TA_NULLでない場合）
		$IF MBF.MBFATR[mbfid] != TA_NULL$
			$ERROR MBF.TEXT_LINE[mbfid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mbfatr", MBF.MBFATR[mbfid], mbfid, "CRE_MBF")$
			$END$
		$END$

$		// maxmszが0以下の場合（E_PAR）［NGKI3307］
		$IF MBF.MAXMSZ[mbfid] <= 0$
			$ERROR MBF.TEXT_LINE[mbfid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"maxmsz", MBF.MAXMSZ[mbfid], mbfid, "CRE_MBF")$
			$END$
		$END$

$		// mbfszが負の場合（E_PAR）［NGKI3308］
		$IF MBF.MBFSZ[mbfid] < 0$
			$ERROR MBF.TEXT_LINE[mbfid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mbfsz", MBF.MBFSZ[mbfid], mbfid, "CRE_MBF")$
			$END$
		$END$

$		// mbfmbがNULLでない場合（E_NOSPT）［ASPS0205］
		$IF !EQ(MBF.MBFMB[mbfid], "NULL")$
			$ERROR MBF.TEXT_LINE[mbfid]$E_NOSPT:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mbfmb", MBF.MBFMB[mbfid], mbfid, "CRE_MBF")$
			$END$
		$END$

$		// メッセージバッファ管理領域
		$IF MBF.MBFSZ[mbfid]$
			static uint_t _kernel_mbfmb_$mbfid$
					[TOPPERS_COUNT_SZ($MBF.MBFSZ[mbfid]$, sizeof(uint_t))];$NL$
		$END$
	$END$

$	// メッセージバッファ初期化ブロック
	const MBFINIB _kernel_mbfinib_table[TNUM_MBFID] = {$NL$
	$JOINEACH mbfid MBF.ID_LIST ",\n"$
		$TAB${$SPC$
			($MBF.MBFATR[mbfid]$),$SPC$
			($MBF.MAXMSZ[mbfid]$),$SPC$
			TOPPERS_ROUND_SZ($MBF.MBFSZ[mbfid]$, sizeof(uint_t)),$SPC$
			$IF MBF.MBFSZ[mbfid]$
				_kernel_mbfmb_$mbfid$
			$ELSE$
				NULL
			$END$$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const MBFINIB, _kernel_mbfinib_table);$NL$
$END$$NL$

$
$  メッセージバッファ管理ブロックとメッセージバッファ機能初期化関数
$
$IF LENGTH(MBF.ID_LIST)$
	MBFCB _kernel_mbfcb_table[TNUM_MBFID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_messagebuf();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(MBFCB, _kernel_mbfcb_table);$NL$
$END$$NL$
